import { CSSProperties, PureComponent } from "react";
import { Subject } from "rxjs";
import { AbstractControl, FormArray, FormControl, FormGroup } from "../model";
import { EnumStatusType, IInputContainerRenderInputParams, IProcessingStatus } from "./useEntityForm/model";
import { IEntityFormState } from "../addons/useEntityForm/model";
export declare type LabelTemplateType = (params: {
    showErrors: boolean;
    validationStatus: EnumStatusType;
    label: string;
}) => any;
interface IInputContainerPureProps<T = any> {
    formState: IEntityFormState;
    control: FormControl | FormGroup | FormArray;
    renderInput: (params: IInputContainerRenderInputParams) => any;
    dataProcessingStatus?: IProcessingStatus<T>;
    showErrorsFn?: (params: {
        form: {
            submitted: boolean;
        };
        input: {
            touched: boolean;
            dirty: boolean;
        };
    }) => boolean;
    processingTemplate?: () => any;
    labelTemplate?: LabelTemplateType;
    errorsTemplate?: (params: {
        errors: any;
        form: {
            submitted: boolean;
        };
        input: {
            touched: boolean;
            dirty: boolean;
        };
    }) => any;
    reloadTemplate?: (params: {
        reloadFn: any;
    }) => any;
    label: string;
    style?: CSSProperties;
    className?: string;
}
export declare class InputContainer extends PureComponent<IInputContainerPureProps, IProcessingStatus> {
    constructor(props: any);
    destroy$: Subject<void>;
    componentDidMount(): void;
    initializeControl(control: AbstractControl): void;
    componentDidUpdate(prevProps: IInputContainerPureProps, prevState: IProcessingStatus): void;
    componentWillUnmount(): void;
    render(): JSX.Element;
}
export {};
