import { Subject } from "rxjs";
import { IAsyncProcessingConfig } from "../../addons/useEntityForm/model";
import { IEntityFormState, IProcessingStatus, PlainObject, PlainObjectType, UseFormGroupConfig, UseFormGroupProps } from "./model";
export declare class EntityFormClass<T = any> {
    private props;
    private setState;
    loadResource$: Subject<{
        id: string;
        params: any;
        config: IAsyncProcessingConfig;
    }>;
    destroy$: Subject<void>;
    reloadResource$: Subject<{
        id: string;
        params: PlainObjectType | PlainObject;
    }>;
    triggerSave$: Subject<any>;
    triggerLoad$: Subject<any>;
    newState: IEntityFormState;
    constructor(props: UseFormGroupProps, setState: (a: (prevState: IEntityFormState) => IEntityFormState) => void);
    private loadResourceConfig;
    init(): void;
    private configLoad;
    private configSave;
    close(): void;
    submit(): void;
    resetSubmit(): void;
    resetForm(): void;
    get formState(): IEntityFormState<any, any>;
    get resources(): {
        [key: string]: IProcessingStatus<any>;
    };
    reloadResource(resourceId: string): void;
    get config(): UseFormGroupConfig;
}
