"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.EntitySearchClass = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _immer = _interopRequireDefault(require("immer"));

var _rxjs = require("rxjs");

var _lang = require("../../utils/lang");

class EntitySearchClass {
  constructor(props, setState) {
    this.props = props;
    this.setState = setState;
    this.destroy$ = new _rxjs.Subject();
    this.reloadResource$ = new _rxjs.Subject();
    this.newState = {
      data: [],
      loadStatus: {},
      paging: {
        page: 0,
        size: 1000,
        sort: null
      },
      params: {},
      resources: {}
    };
    this.reloadResource = this.reloadResource.bind(this);
  }

  reloadResource(resourceId) {}

  init() {
    const resources = this.props.resources || {};
    Object.keys(resources).map(key => (0, _extends2.default)({}, resources[key], {
      key
    })).filter(resource => !resource.concurrent).forEach(resource => {
      this.setState(prevState => {
        const newState = (0, _immer.default)(draft => {
          draft.resources[resource.key] = {};
        })(prevState);
        this.newState = newState;
        return newState;
      });
      const processingStatus$ = new _rxjs.Subject();
      (0, _rxjs.merge)(processingStatus$.pipe((0, _rxjs.mapTo)({
        status: 'PROCESSING'
      })), (0, _rxjs.merge)(this.reloadResource$.pipe((0, _rxjs.filter)(reload => reload.id === resource.key), (0, _rxjs.map)(reload => reload.params)), resource.params$).pipe((0, _rxjs.takeUntil)(this.destroy$), (0, _rxjs.tap)(params => {
        // this.setState(
        //     (prevState) => {
        //         const newState = produce(
        //             (draft: IEntitySearchState) => {
        //                 draft.resourceParams[resource.key] = params;
        //             }
        //         )(prevState);
        //         this.newState = newState;
        //         return newState
        //     }
        // )
        processingStatus$.next();
      }), (0, _rxjs.switchMap)(params => {
        return resource.loadData$(params).pipe( // take(1),
        (0, _rxjs.map)(data => {
          alert(2);
          return {
            status: 'PROCESSED',
            data
          };
        }), (0, _rxjs.catchError)(error => {
          alert(9);
          return (0, _rxjs.of)({
            status: 'ERROR',
            error
          });
        }));
      }))).pipe((0, _rxjs.takeUntil)(this.destroy$), (0, _rxjs.tap)(processingStatus => {
        alert(1);
        resource.onProcessingStatus && resource.onProcessingStatus(processingStatus, {});
        this.setState(prevState => {
          const newState = (0, _immer.default)(draft => {
            draft.resources[resource.key].status = processingStatus.status;
            draft.resources[resource.key].data = processingStatus.data;
            draft.resources[resource.key].error = processingStatus.error;
          })(prevState);
          this.newState = newState;
          return newState;
        });
      })).subscribe();
    });
    /******************************************************************************************************* */

    /******************************************************************************************************* */

    /******************************************************************************************************* */

    const defaultAdaptLoadData = (data, resources) => ({
      data,
      resources: {}
    });

    const adaptLoadData = this.props.adaptLoadData ? this.props.adaptLoadData : defaultAdaptLoadData;
    const processingStatus$ = new _rxjs.Subject();
    (0, _rxjs.merge)(processingStatus$.pipe((0, _rxjs.mapTo)({
      status: 'PROCESSING'
    })), this.props.params$.pipe((0, _rxjs.takeUntil)(this.destroy$), (0, _rxjs.tap)(params => {
      this.setState(prevState => {
        const newState = (0, _immer.default)(draft => {
          draft.params = params;
        })(prevState);
        this.newState = newState;
        return newState;
      });
      processingStatus$.next();
    }), (0, _rxjs.switchMap)(params => {
      /********************************* */
      const resources = this.props.resources || {};
      const concurrentResources = Object.keys(resources).map(key => (0, _extends2.default)({}, resources[key], {
        key
      })).filter(resource => resource.concurrent);
      const loadResources$ = concurrentResources.map(resource => {
        if (resource.cache) {
          const resourceOld = this.newState.resources[resource.key];

          if (resourceOld && resourceOld.status === 'PROCESSED') {
            return (0, _rxjs.of)({
              status: 'PROCESSED',
              data: {
                key: resource.key,
                data: resourceOld.data
              }
            });
          }
        }

        return resource.loadData$(params).pipe((0, _rxjs.map)(data => {
          return {
            status: 'PROCESSED',
            data: {
              key: resource.key,
              data
            }
          };
        }), (0, _rxjs.catchError)(error => {
          return (0, _rxjs.of)({
            status: 'PROCESSED',
            error: {
              key: resource.key,
              error
            }
          });
        }));
      });
      /********************************* */

      const concurrentResources$ = (loadResources$.length ? (0, _rxjs.forkJoin)(loadResources$) : (0, _rxjs.of)([])).pipe((0, _rxjs.map)(resources => {
        return resources.reduce((t, e) => {
          var _e$data, _e$error, _e$data2, _e$error2;

          t[((_e$data = e.data) == null ? void 0 : _e$data.key) || ((_e$error = e.error) == null ? void 0 : _e$error.key)] = {
            status: e.status,
            data: (_e$data2 = e.data) == null ? void 0 : _e$data2.data,
            error: (_e$error2 = e.error) == null ? void 0 : _e$error2.error
          };
          return t;
        }, {});
      }));
      const data$ = this.props.loadData$(params);
      const loadData$ = _lang.ModuleUtils.isObservable(data$) ? data$ : _lang.ModuleUtils.isPromise(data$) ? (0, _rxjs.from)(data$) : (0, _rxjs.of)(data$);
      return (0, _rxjs.zip)(loadData$, concurrentResources$).pipe((0, _rxjs.take)(1), (0, _rxjs.map)(([data, resources]) => adaptLoadData(data, resources)), (0, _rxjs.map)(data => {
        return {
          status: 'PROCESSED',
          data
        };
      }), (0, _rxjs.catchError)(error => {
        return (0, _rxjs.of)({
          status: 'ERROR',
          error
        });
      }));
    }))).pipe((0, _rxjs.takeUntil)(this.destroy$), (0, _rxjs.tap)(processingStatus => {
      this.props.onProcessingStatus && this.props.onProcessingStatus(processingStatus, {});

      if (processingStatus.status === 'PROCESSED') {
        this.setState(prevState => {
          const newState = (0, _immer.default)(draft => {
            const resources = processingStatus.data.resources;
            Object.keys(resources || {}).map(key => ({
              key,
              data: resources[key]
            })).forEach(item => {
              draft.resources[item.key] = {
                status: 'PROCESSED',
                data: item.data
              };
            });
          })(prevState);
          this.newState = newState;
          return newState;
        });
      }

      this.setState(prevState => {
        const newState = (0, _immer.default)(draft => {
          var _processingStatus$dat, _processingStatus$dat2;

          draft.loadStatus.status = processingStatus.status;
          draft.loadStatus.data = (_processingStatus$dat = processingStatus.data) == null ? void 0 : _processingStatus$dat.data;
          draft.loadStatus.error = processingStatus.error;
          draft.data = (_processingStatus$dat2 = processingStatus.data) == null ? void 0 : _processingStatus$dat2.data;
        })(prevState);
        this.newState = newState;
        return newState;
      });
    })).subscribe();
  }

  close() {
    this.destroy$.next();
    this.destroy$.complete();
  }

  get config() {
    return {
      searchStatus: this.newState
    };
  }

}

exports.EntitySearchClass = EntitySearchClass;